Attribute VB_Name = "Module1"
Option Explicit

Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Const WM_ACTIVATEAPP = &H1C
Public Const GWL_WNDPROC = -4

Global lpPrevWndProc As Long
Global gHW As Long

Public Sub Hook()
   'Establish a hook to capture messages to this window
   lpPrevWndProc = SetWindowLong(gHW, GWL_WNDPROC, AddressOf WindowProc)
End Sub

Public Sub Unhook()

   Dim temp As Long

   'Reset the message handler for this window
   temp = SetWindowLong(gHW, GWL_WNDPROC, lpPrevWndProc)

End Sub

Function WindowProc(ByVal hw As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   'Check for the ActivateApp message

   If uMsg = WM_ACTIVATEAPP Then
       'Check to see if Activating the application
       If wParam <> 0 Then
           'Application Received Focus
           Form1.Caption = "Focus Restored"
       Else
           'Application Lost Focus
           Form1.Caption = "Focus Lost"
       End If
   End If

   'Pass message on to the original window message handler
   WindowProc = CallWindowProc(lpPrevWndProc, hw, uMsg, wParam, lParam)
   
End Function

